/*
	DatelibC v0.1 beta                22/09/2005
	Par Raoul PREVOST (Thepro).
*/

#define ClockOn _rom_call(void,(void),5F5)
#define DateAndTime_Get _rom_call(void,(unsigned short*,unsigned short*,unsigned short*,unsigned short*,unsigned short*,unsigned short*),5F3)

#define DATE_TAG LIST_TAG

typedef struct {long long int annee;unsigned short jour,mois,heure,minute,seconde;} date;
typedef struct {long long int jour;unsigned short heure,minute,seconde;} jrhms;
typedef struct {long long int jour;int mois,annee;} jma;
short loc_est_CET=1;
short loc_dec_heure=0,loc_dec_minute=0;


short estbssxt(long long int annee);
date Date_courante(void);
void push_date(date d);
date GetDate(ESI argptr);
#define GetDateArg(argprt) ({date d=GetDate((ESI)argptr);SkipArg((ESI)argptr);d;})
unsigned short nb_jours_du_mois(unsigned short mois,long long int annee);
#define nb_jours_du_mois_date(d) nb_jours_du_mois(((date)d).mois,((date)d).annee)
date decalage_date(date d,int heure,int minute);
int nb_jours_avant_mois(int mois,long long int annee);
#define nb_jours_avant_mois_date(d) nb_jours_avant_mois(((date)d).mois,((date)d).annee)
#define nb_jours_annee(a) ((unsigned short)(estbssxt((long long int)a)?366:365))
#define nb_jours_annee_date(d) nb_jours_annee(((date)d).annee)
long long int nb_jours_avant_annee(long long int annee);
#define nb_jours_avant_annee_date(d) nb_jours_avant_annee(((date)d).annee)
long long int num_jour(date d);
#define nb_jours_entre_2_dates(d1,d2) (num_jour((date)d2)-num_jour((date)d1))
short jour_semaine(date d);
short en_ete (date d);
jrhms nb_jrhms(long long int seconde);
date SECtoDATE(long long int seconde);
long long int DATEtoSEC(date d);
#define UNItoUTC(u) SECtoDATE((long long int)u+62135596800ll)
#define UTCtoUNI(d) (DATEtoSEC((date)d)-62135596800ll)
#define WINtoLOC(w) SECtoDATE((long long int)w/10000000)
#define LOCtoWIN(d) (DATEtoSEC((date)d)*10000000)
#define UTCtoCET(d) decalage_date((date)d,(en_ete((date)d) ? 2 : 1),0)
#define CETtoUTC(d) decalage_date((date)d,(en_ete((date)d) ? -2 : -1),0)
#define CETtoLOC(d) decalage_date((loc_est_CET ? d : CETtoUTC(d)),loc_dec_heure,loc_dec_minute)
#define LOCtoCET(d) ({date t=decalage_date(d,-loc_dec_heure,-loc_dec_minute);(loc_est_CET ? t : UTCtoCET(t));})
#define UTCtoLOC(d) CETtoLOC(UTCtoCET((date)d))
#define UTCtoWIN(d) LOCtoWIN(UTCtoLOC((date)d))
#define CETtoUNI(d) UTCtoUNI(CETtoUTC((date)d))
#define CETtoWIN(d) LOCtoWIN(CETtoLOC((date)d))
#define LOCtoUTC(d) CETtoUTC(LOCtoCET((date)d))
#define LOCtoUNI(d) UTCtoUNI(LOCtoUTC((date)d))
#define UNItoCET(u) UTCtoCET(UNItoUTC((long long int)u))
#define UNItoLOC(u) UTCtoLOC(UNItoUTC((long long int)u))
#define UNItoWIN(u) LOCtoWIN(UNItoLOC((long long int)u))
#define WINtoUTC(w) LOCtoUTC(WINtoLOC((long long int)w))
#define WINtoCET(w) LOCtoCET(WINtoLOC((long long int)w))
#define WINtoUNI(w) LOCtoUNI(WINtoLOC((long long int)w))
jma nb_jrmoan_entre_2_dates(date d1,date d2);
int num_semaine(date d);
void formater_date(date d,char* ch);